
#import "Figure.h"

// Inicia posible definicion en NSObjCRuntime.h
#if !defined(MIN)
    #define MIN(x,y)  (((x)<(y))?(x):(y))
#endif

#if !defined(MAX)
    #define MAX(x,y)  (((x)>(y))?(x):(y))
#endif

#if !defined(ABS)
    #define ABS(A)    (((A)<0)?(-(A)):(A))
#endif
// Finaliza posible definicion en NSObjCRuntime.h


@interface Connection : Figure 
{
   NSPoint startPoint; 
   NSPoint endPoint; 
   id      startGraph; 
   id	   endGraph; 
   int     weight; 
}

// Class methods
+ (NSColor *)color;
+ (void)setColor: (NSColor *)aColor;
+ (void)makeArrow;
+ (void)releaseHeadArrow;

- (id)initWithFrame:(NSRect)frameRect inView:(id)contentView;
- (void)reinitWithStartPointIn:(id) ngraph;
- (void)dealloc;
- (NSBezierPath *)bezierPath;

//- (void)mouseUp:(NSEvent *)theEvent;
- (void)mouseDragged:(NSEvent *)theEvent;

- (void)setWeight: (int)w;
- (int)weight; 

- (tGraph)typeGraph; 
- (void)from:(id)fromGraph; 
- (void)setEndGraph:(id)endG; 
- (id)startGraph; 
- (id)endGraph;

@end
