/*
 *                      forwardI
 *                         ^
 *                         |
 *          forwardJ <- current -> nextJ
 *                         |
 *                         v
 *                       nextI
 */
#import <AppKit/AppKit.h>

@interface Element  : NSObject <NSCoding>
{
   unsigned int posI; 		/* Posicion I en la matriz (renglon) */ 
   unsigned int posJ; 		/* Posicion J en la matriz (columna) */ 
   Element      *nextI; 	/* Siguiente elemento (renglon)      */ 
   Element      *forwardI; 	/* Anterior elemento (renglon)       */
   Element      *nextJ;		/* Siguiente elemento (columna)      */
   Element      *forwardJ;      /* Anterior elemento (columna)       */ 
   id           content;	/* Contenido del elemento (generico) */ 
}

- (id)init;
- (void)dealloc; 

- (void)setNextI: (Element *)nxt;
- (void)setForwardI: (Element *)fwd;
- (void)setNextJ: (Element *)dwn;
- (void)setForwardJ: (Element *)u;
- (void)setCoordI: (int) i J:(int)j; 
- (void)setContent: (id)anObject;
- (Element *)nextI;
- (Element *)forwardI;
- (Element *)nextJ;
- (Element *)forwardJ;
- (int)posI; 
- (int)posJ;
- (id)content;

@end
