#import <AppKit/AppKit.h>

#define PLACE      0x10
#define TRANSITION 0x11
#define ARC        0x12
#define TOKEN      0x13

typedef int tGraph; 

@interface Figure  : NSObject <NSCoding>
{
    NSRect 	  frame; 
    NSString	  *figLabel;
    id 	  	  superView;
    NSPoint       old; 
    BOOL	  selected;
    BOOL          reference; 
}

- (id)initWithFrame:(NSRect)frameRect inView:(id)contentView;
- (void)dealloc;
- (NSRect)frame; 
- (void)setFrame:(NSRect)newFrame;
- (NSWindow *)window;
- (NSPoint)convertPoint:(NSPoint)punto fromView:(id)contentView; 

- (id)superview;
- (void)setSuperview: (id)contentView;
- (void)drawFigure;
- (void)drawLabel; 

- (void)setLabel: (NSString *)aLabel; 
- (NSString *)label; 

/* Handle  events */
- (NSBezierPath *)bezierPath; 
- (NSPoint)deltaPositionTo:(NSEvent *)theEvent;
- (void)moveToRelativePoint: (NSPoint)d;
//- (BOOL)containsPoint: (NSPoint)p; 
- (BOOL)canResponseToEvent:(NSEvent *)theEvent; 
- (void)mouseDown:(NSEvent *)theEvent; 
- (void)mouseUp:(NSEvent *)theEvent; 
- (void)mouseDragged:(NSEvent *)theEvent; 

- (tGraph)typeGraph; 
- (BOOL)isSelected;
- (void)setSelected:(BOOL)isel;
- (NSPoint) pointCenter;
- (void)descripcion; 

// Class methods
+ (NSColor *)color; 
+ (void)setColor: (NSColor *)aColor; 

@end
