/* 
 * Class Matrix 
 * This class represent a generic matrix, width [(nRows)x(nColumns)] objets of 
 * class Element. This class is PNMatrix's base class. 
 * 
 * When create an objejt of this class, the matrix is empty. This means that: 
 * 1>   nRows = nColumns = 0; 
 * 2>   base = nil; 
 * 3>   current = nil; 
 * 
 * The elements in the matrix have numbers in [0, nRows) in i, 
 * and have numbers in [0, nColumns) in j.  
 */


#import <AppKit/AppKit.h>
#import <stdlib.h>
#import "Element.h" 

@interface Matrix  : NSObject <NSCoding>
{
   unsigned int nRows; 
   unsigned int nColumns; 
   Element      *base; 
   Element      *current;
}

- (id)init; 
- (void)dealloc; 

- (Element *)current;
- (Element *)gotoI:(int) iI J:(int) iJ; 
- (Element *)bestFromForI:(int) iI J:(int)iJ; 
- (Element *)home; 

- (Element *)findElementWithObject:(id)anObject; 

- (void)addColumn;
- (void)addRow; 
- (void)deleteColumn: (int) iJ; 
- (void)deleteRow: (int) iI;
- (void)removeContentOfCurrent; 

- (void)setCurrent: (Element *)c;
- (void)reenumerate;

- (int)rows;
- (int)columns;

@end
