//
//  PNDocument.m
//  PetrA
//
//  Created by Amilcar Meneses Viveros on Fri Jan 23 2004.
//  Copyright (c) 2004 CINVESTAV. All rights reserved.
//

#import "PNDocument.h"
#import <objc/objc-runtime.h>			// for objc_msgSend
#import "PNView.h"
#import "PNController.h"

int pndocument=0; 
PNInspectorController *controller; 

@implementation PNDocument

+(void)initialize
{
   controller=nil;
}

+ (void)setInspectorController: (PNInspectorController *)aController
{
   controller=aController; 
}

+ (PNInspectorController *)inspectorController
{
   return controller; 
}

/* 
+ (void)reviewChangesAndQuitEnumeration:(BOOL)cont 
{
   if (cont) {
      NSArray *windows = [NSApp windows];
      unsigned count = [windows count];
      while (count--) {
         NSWindow *window = [windows objectAtIndex:count];
         PNDocument *document=[[PNController documentController] documentForWindow:window];
         if (document) {
            if ([window isDocumentEdited]) {
               [document askToSave:@selector(reviewChangesAndQuitEnumeration:)];
               return;
            }
         }
      }
   }
   [NSApp replyToApplicationShouldTerminate:cont];
}
*/ 

- (id)init
{
    self = [super init];
    if (self) {
       pnmatrix=nil; 
       pndocument++; 
       [controller setEnableInspectorPanel:YES];
    }
    return self;
}

- (NSString *)windowNibName
{
    return @"PNDocument";
}

- (void)windowControllerDidLoadNib:(NSWindowController *) aController
{
    [super windowControllerDidLoadNib:aController];
}
 
- (BOOL)writeToFile:(NSString *)fileName ofType:(NSString *)type 
{
   if ([pnet isRunning]) return false; 
   BOOL sr = [NSArchiver archiveRootObject:[pnet pnMatrix] toFile:fileName]; 
   if (sr) [[pnet window] setDocumentEdited:NO]; 
   return sr; 
}
- (BOOL)readFromFile:(NSString *)fileName ofType:(NSString *)type 
{
   pnmatrix = [[NSUnarchiver unarchiveObjectWithData:
              [NSData dataWithContentsOfFile:fileName]] retain];
   return YES;
}

- (void)printShowingPrintPanel:(BOOL)flag
{
   NSView *printView = [pnet printableView];
   NSPrintOperation *op = [NSPrintOperation printOperationWithView:printView
                           printInfo:[self printInfo]];
    [op setShowPanels:YES];
    [self runModalPrintOperation:op delegate:nil
          didRunSelector:NULL contextInfo:NULL];
}

// Metodos sender-target
- (void)cut:(id)sender
{
   [pnet cut:sender];
}

- (void)selectAll:(id)sender
{
   [pnet selectAll:sender]; 
}

- (PNMatrix *)pnMatrix
{
   return pnmatrix; 
}

- (BOOL)isDocumentEdited
{
  return [[pnet window] isDocumentEdited]; 
}

- (void)windowWillClose:(NSNotification *)aNotification
{
   pndocument--;  
   if (pndocument<1) 
      [controller setEnableInspectorPanel:NO]; 
}

- (void)updatePreferences
{
   [pnet setNeedsDisplay:YES];
}
@end
