/* PNInspectorController */

#import <Cocoa/Cocoa.h>

#define PETRI_NET_INFO		1000
#define PLACE_INFO		1001
#define TRANSITION_INFO		1002
#define CONNECTION_INFO		1003

@interface PNInspectorController : NSObject
{
   IBOutlet id inspectorPanel;
   IBOutlet id inspectorItem;
   IBOutlet id infConnection;
   IBOutlet id infPetriNet;
   IBOutlet id infPlace;
   IBOutlet id infTransition;
   IBOutlet id labelPlace;
   IBOutlet id labelTransition;
   IBOutlet id multipleView;
   IBOutlet id places;
   IBOutlet id tokens;
   IBOutlet id transitions;
   IBOutlet id weight;
   IBOutlet id enableTransition;
   IBOutlet id enableLabels;
   
   id figure; 
   int cInfo; 			// current info view panel... 
   BOOL  enable; 
}

- (void)awakeFromNib; 
- (void)setPagToView: (id)theView;

// sender-target methods 
- (IBAction)enableLabels:(id)sender;
- (IBAction)enableTransition:(id)sender;
- (IBAction)setInfoConnection:(id)sender;
- (IBAction)setInfoPlace:(id)sender;
- (IBAction)setInfoTransition:(id)sender;

- (IBAction)displayInspectorPanel:(id)sender;

// display info methods
- (void)displayPetriNetInfo: (id)anPNet;
- (void)displayPlaceInfo:(id)anPlace;
- (void)displayTransitionInfo:(id)anTransition;
- (void)displayConnectionInfo:(id)anConnection;

- (void)setEnableInspectorPanel: (BOOL)aFlag; 
- (BOOL)validateMenuItem:(NSMenuItem *)anItem; 
@end
