/*
 * Clase PNMatrix
 * Los objetos de esta clase se encargaran de establecer una red de 
 * conecciones --- de nRows X nColumns---. Es decir, se encarga de enviar 
 * mensajes a sus diferentes elementos. 
 * 
 */

//#import <AppKit/AppKit.h>
//#import <stdlib.h>
#import "Matrix.h"
#import "Connection.h"

#define NEW_CONNECTION	   100
#define DELETE_CONNECTION  101
#define MODIFY_CONNECTION  102

typedef int result_add;

@interface PNMatrix  : Matrix  
{
   int nPlaces;		// Number of places 
   int nTransitions;	// Number of transition 
   int nLinks; 		// Number of Links 
   BOOL dl; 
}

- (id)init; 
- (unsigned)count; 
- (int)countPlaces; 
- (int)countTransitions;
- (int)countLinks;
- (void)addPlace: (id)newPlace;
- (void)addTransition: (id)newTransition;
- (void)deletePlaceInRow: (int)i; 
- (void)deleteTransitionInColumn: (int)j;

- (result_add)addConnection: (id)newConnection; 

- (id)placeCanResponseToEvent:(NSEvent *)theEvent;
- (id)transitionCanResponseToEvent:(NSEvent *)theEvent;
- (id)graphCanResponseToEvent:(NSEvent *)theEvent;

// Execute Transitions...
- (void)runTransitions; 

// Esta parte se debe mover a otro punto de la aplicacion ... 
- (void)setDisplayLabels:(BOOL)aFlag; 
- (BOOL)displayLabels; 

@end
