
#import <AppKit/AppKit.h>
#import <Foundation/NSArray.h>
#import "PNMatrix.h"
//#import "PNRenderingView.h"

@interface PNView : NSView 
{
   id             controller;      	// Control object (PNDocument) 
   PNMatrix       *matrixC;		// Connectivity Matrix
   NSMutableArray *_graphics;		// Graphics Objects Array 
   NSMutableArray *_selectedGraphics;   // Selected Graphics Objects Array 
   id   	  lastGraph;		// Last Graph builded
   Class   	  factory; 		// New graphic object's class
   BOOL           running; 
//   BOOL		  dlabels;		// enable display figure labels 
}

// Initialice and finalize methods 
- (id)initWithFrame:(NSRect)frameRect;
- (void)dealloc;
 
// Methods sender-target
- (void)runPetriNet:(id)sender;
- (void)selectAll:(id)sender;
- (void)cut:(id)sender;
//- (void)print:(id)sender;

// Manejo de objetos desplegados y seleccionados 
- (void)addGraphic:(id)aGraphic;
- (void)addGraphicAtInit:(id)aGraphic;
- (void)removeGraphicAtInit;
- (void)removeGraphic:(id)aGraphic;
- (void)addSelectedGraphic: (id)aGraphic;
- (void)removeAllSelectedObjects;
- (void)removeSelectedGraphic:(id)aGraphic;
- (void) moveAllSelectGraphicsToPoint:(NSPoint)d;

// state 
- (id)pnMatrix;
- (void)setPNMatrix:(id)nMatrix;
- (BOOL)isRunning; 
- (void)displayControlled;
- (BOOL)canDisplayLabels; 
- (void)setDisplayLabels:(BOOL)e;

- (id) printableView;

@end
/*
// Metodos para ayudar en la impresion del documento
- (NSSize)documentSize;
- (NSPrintInfo *)printInfo; 


// Metodos reescritos de la superclase
- (void)setFrameSize:(NSSize)newSize;

@end
*/
