#import "Place.h"
#import <math.h>

NSColor *colorP;

@implementation Place

// Class Methods
+ (NSColor *)color
{
    return colorP;
}

+ (void)setColor: (NSColor *)aColor
{
   if (colorP==nil)  colorP = [aColor retain];
   else if (![colorP isEqualTo:aColor]) {
      [colorP autorelease];
      colorP = [aColor retain];
   }
}

// Instace Methods 
- (id)initWithFrame:(NSRect)frameRect inView:(id)contentView 
{
    NSRect fr;

    [super initWithFrame:frameRect inView:contentView];
    fr = [self frame];
    old = fr.origin; 
    fr.origin.x -= LRADIO;
    fr.origin.y -= LRADIO;
    fr.size.width = fr.size.height = LRADIO+LRADIO;
    [self setFrame:fr];
    ntokens = 0;
    return self;
}

- (void)dealloc
{
   [super dealloc];
}

- (NSBezierPath *)bezierPath
{
   NSBezierPath *drw; 

   drw = [NSBezierPath bezierPathWithOvalInRect:[self frame]];
   [drw setLineWidth:0.6]; 
    return drw; 
}

- (void)drawFigure
{
   NSBezierPath *drw = [self bezierPath]; 
   NSColor *tc = (selected)? [Figure color] : [Place color]; 
   [tc set];
   [drw fill];
   [[NSColor blackColor] set]; 
   [drw stroke];

   if (ntokens>0) {
      int i;
      float d, dt, t;
      NSPoint c; 
      NSRect fr = [self frame];
      c.x = frame.origin.x+frame.size.width/2;
      c.y = frame.origin.y+frame.size.height/2;
      fr.size.width=fr.size.height=ATOKEN+ATOKEN;
      switch (ntokens){
      case  1:
            fr.origin.x = c.x-ATOKEN;
            fr.origin.y = c.y-ATOKEN;
            drw = [NSBezierPath bezierPathWithOvalInRect:fr];
            [[NSColor blackColor] set];
            [drw fill];
            [drw stroke];
            break;
      case  2:
      case  3:
            d = LRADIO/2.0; 
            t = 0;
            dt = 2*3.1416/ntokens; 
            for (i=0; i<ntokens; i++) {
               fr.origin.x = cos(t)*d + c.x - ATOKEN;
               fr.origin.y = sin(t)*d + c.y - ATOKEN;
               drw = [NSBezierPath bezierPathWithOvalInRect:fr];
               [[NSColor blackColor] set];
               [drw fill];
               [drw stroke];
               t+=dt; 
            }
            break; 
      default:
            d = LRADIO/2.0;
            t = 0;
            dt = 2*3.1416/(ntokens-1.0); 
            fr.origin.x = c.x-ATOKEN;
            fr.origin.y = c.y-ATOKEN;
            i=0; 
            do {
               drw = [NSBezierPath bezierPathWithOvalInRect:fr];
               [[NSColor blackColor] set];
               [drw fill];
               [drw stroke];
               fr.origin.x = cos(t)*d + c.x - ATOKEN;
               fr.origin.y = sin(t)*d + c.y - ATOKEN;
               t+=dt; 
               i++; 
            } while(i<ntokens);
            break; 
      }
   }
}

- (int)tokens
{
    return ntokens; 
}

- (void)addToken
{
   ntokens++; 
}

- (void)setTokens:(int)n
{
    ntokens=n;     
}

- (tGraph)typeGraph
{
    return PLACE;
}

-(void) descripcion
{
    [super descripcion]; 
}

// Protocolo NSCoding
- (void)encodeWithCoder:(NSCoder *)aCoder
{
    [super encodeWithCoder: aCoder];
    [aCoder encodeValuesOfObjCTypes: "i", &ntokens];
}

- (id)initWithCoder:(NSCoder *)aDecoder
{
    self = [super initWithCoder: aDecoder];
    [aDecoder decodeValuesOfObjCTypes: "i", &ntokens];

    return self;
}

@end 
